#define MAX_OSNAMES	3

typedef struct ping_signatures {
    char    *osnames[MAX_OSNAMES];	/* array of the known OS's	*/
    char    *signature;			/* pointer to unique echo data 	*/
    int      length;			/* length of this data		*/
    u_short  offset;			/* offset from end ICMP header 	*/
} pingdb_t;

/*
 * Assign multiple Operating Systems to a unique known ping.
 */
pingdb_t pingdb[] = {
{
   /*
    * BSD/OS, FreeBSD, NetBSD, OpenBSD 2.5, Linux, Solaris 2.5 - 2.7
    */
    { "BSD Classic", NULL },
    "\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17"
    "\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f\x20\x21\x22\x23\x24\x25\x26\x27"
    "\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f\x30\x31\x32\x33\x34\x35\x36\x37",
    48,
    8
},
{
    { "OpenBSD 2.4", NULL },
    "\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f"
    "\x20\x21\x22\x23\x24\x25\x26\x27\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f"
    "\x30\x31\x32\x33\x34\x35\x36\x37\x00\x00\x00\x00\x00\x00\x00\x00",
    48,
    8
},
{  
    { "Cisco IOS 9.x", NULL },
    "\xab\xcd\xab\xcd\xab\xcd\xab\xcd\xab\xcd\xab\xcd\xab\xcd\xab\xcd"
    "\xab\xcd\xab\xcd\xab\xcd\xab\xcd\xab\xcd\xab\xcd\xab\xcd\xab\xcd"
    "\xab\xcd\xab\xcd\xab\xcd\xab\xcd\xab\xcd\xab\xcd\xab\xcd\xab\xcd"
    "\xab\xcd\xab\xcd\xab\xcd\xab\xcd\xab\xcd\xab\xcd\xab\xcd\xab\xcd"
    "\xab\xcd\x00\x00",
    68,
    4
},
{ 
    { "CyberKit 2.2 - Windows", NULL },
    "\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa"
    "\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa"
    "\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa"
    "\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa",
    64,
    0
},  
{
   /*
    * Pinging from Delphi code written by F. Piette
    */
    { "DDS Ping Standard - Windows", NULL },
    "\x50\x69\x6e\x67\x69\x6e\x67\x20\x66\x72\x6f\x6d\x20\x44\x65\x6c"
    "\x70\x68\x69\x20\x63\x6f\x64\x65\x20\x77\x72\x69\x74\x74\x65\x6e"
    "\x20\x62\x79\x20\x46\x2e\x20\x50\x69\x65\x74\x74\x65\x20\x20\x20"
    "\x20\x20\x20\x20\x20\x20\x20\x20",
    56,
    0
},
{  
    { "Flowpoint 2200 DSL Router", NULL },
    "\x01\x02\x03\x04\x05\x06\x07\x08\x09\x0a\x0b\x0c\x0d\x0e\x0f\x10"
    "\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f\x20"
    "\x21\x22\x23\x24\x25\x26\x27\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f\x30"
    "\x31\x32\x33\x34\x35\x36\x37",
    55,
    5
}, 
{
    { "IPNetMonitor - Macintosh", NULL },
    "\xa9\x20\x53\x75\x73\x74\x61\x69\x6e\x61\x62\x6c\x65\x20\x53\x6f"
    "\x66\x74\x77\x6f\x72\x6b\x73\x2e",
    24,
    0
},
{
    { "Microsoft Windows", NULL },
    "\x61\x62\x63\x64\x65\x66\x67\x68\x69\x6a\x6b\x6c\x6d\x6e\x6f\x70"
    "\x71\x72\x73\x74\x75\x76\x77\x61\x62\x63\x64\x65\x66\x67\x68\x69",
    32,
    0
},
{
    { "Network Toolbox 3 - Windows", NULL },
    "\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d"
    "\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d"
    "\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d\x3d",
    48,
    0
},
{
   /*
    * Nmap 2.36BETA.
    */
    { "\"No Data\"", NULL },
    "",
    0,
    0
},
{
   /*
    * Data
    */
    { "Pinger - Windows", NULL },
    "\x44\x61\x74\x61\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
    "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00",
    32,
    0
},
{
    { "Ping-O-Meter - Windows", NULL },
    "\x4f\x4d\x65\x74\x65\x72\x4f\x62\x65\x73\x65\x41\x72\x6d\x61\x64"
    "\x69\x6c\x6c\x6f\x53\x6f\x66\x74\x77\x61\x72\x65",
    28,
    0
},
{  
    { "Ping Plotter 1.x - Windows", NULL },
    "\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa"
    "\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa"
    "\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa"
    "\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa",
    56,
    0
}, 
{  
    { "Ping Plotter 2.x - Windows", NULL },
    "\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa"
    "\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa"
    "\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa"
    "\xaa\xaa\xaa\xaa\xaa\xaa",
    54,
    2
}, 
{
    { "PingPlus - Windows", NULL },
    "\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa"
    "\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa\xaa",
    32,
    0
},
{
    { "Seer - Windows", NULL },
    "\x88\x04\x20\x20\x20\x20\x20\x20\x20\x20\x20\x20\x20\x20\x20\x20"
    "\x20\x20\x20\x20\x20\x20\x20\x20\x20\x20\x20\x20\x20\x20\x20\x20",
    32,
    0
},
{
    { "TJPingPro 1.1 Build 2 / Windows", NULL },
    "\x54\x4a\x50\x69\x6e\x67\x50\x72\x6f\x20\x62\x79\x20\x4a\x69\x6d"
    "\x20\x44\x75\x6e\x6e\x65\x2e\x20\x43\x6f\x70\x79\x72\x69\x67\x68"
    "\x74\x20\xa9\x20\x31\x39\x39\x37\x2e\x20\x41\x6c\x6c\x20\x52\x69"
    "\x67\x68\x74\x73\x20\x52\x65\x73\x65\x72\x76\x65\x64\x2e",
    62,
    0
},
{  
    { "Whatsup Gold - Windows", NULL },
    "\x57\x68\x61\x74\x73\x55\x70\x20\x2d\x20\x41\x20\x4e\x65\x74\x77"
    "\x6f\x72\x6b\x20\x4d\x6f\x6e\x69\x74\x6f\x72\x69\x6e\x67\x20\x54"
    "\x6f\x6f\x6c\x27\x73\x20\x50\x69\x6e\x67\x20\x44\x61\x74\x61\x20"
    "\x57\x68",
    50,
    0
}, 
{
   /* 
    * ISSPNGRQ
    */
    { "Internet Security Scanner Pinger v1.0", NULL },
    "\x49\x53\x53\x50\x4e\x47\x52\x51",
    8,
    8
},
{
    { "Windows NT tracert", NULL },
    "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
    "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
    "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
    "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00",
    64,
    0
},
{
    { "Netscreen Firewall Ping", NULL },
    "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
    "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
    "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
    "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
    "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
    "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"
    "\x00\x00\x00\x00",
    100,
    0
},
{
    { "BeOS 4.x", NULL },
    "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x08\x09\x0a\x0b"
    "\x0c\x0d\x0e\x0f\x10\x11\x12\x13",
    24,
    6
},
{ { NULL }, NULL, 0, 0 },
};
